/**
*
* Módulo Mapa 
*
* Este módulo utiliza el patrón de diseño en javascript This Namespace Proxy
* este patrón permite encapsular las variables y añadir funciones más adelante.
*
* Antonio Cabezón Cascante 
* TFC 2012-2013 UOC
*
*/


var mapModule = function(args){
  
  /**
  *
  * Variables públicas dentro del módulo
  *
  **/
  var container = '';
  var theMap;
  var phy,str,hyb,sat;
  var rios,vertidos;
  var vulnerables,ren;
  var fuentesPuntuales, fuentesDifusas, extracciones, regulaciones, morfologicas, antropogenicas, usos;
  var limite;
  var feature;
  var vectors;
  var createControl,editControl;
  var lresult;
  var featureLayer = null;
  var aedit = false;
  var aadd = false;
  /**
  *
  * Nos devuelve el mapa para poder trabajar con él desde el exterior del módulo
  *
  **/
  this.hideAllPanels = function(){
	  $('#resultsPanel').hide();
	  $('#editPanel').hide();
	  $('#layerPanel').hide();
	  $('#logPanel').hide();
  }
  
  this.featureLayerChange = function(val){
		this.featureLayer = eval(val);
		//this.activeFeature();		  
  }
  
  
  this.log = function(user, pass){
	 if(user=="demo" && pass =="1234"){
	 		 $('#layerLock').find("img").attr("src", "img/unlock.png");
	 		 $('#layerAdd').show();
	 		 $('.locked').show();
	 		 $('#logPanel').data("old", $('#logPanel').html());
			 $('#logPanel').html('<span class="title">Registro:</span><br/><br/><form  name="log" class="addForm">Ya está logado, haga clic <a href="#" onclick="mapa.logout()">aquí</a> para cerrar la sesión</form>');
			 localStorage.setItem('log', 'OK');
	 }else{
		 alert("Autenticación inválida, inténtelo de nuevo");
	 }
  }
  
  this.logout = function(){
  	 $('#layerAdd').hide();
  	 $('.locked').hide();
  	 $('#layerLock').find("img").attr("src", "lock.png");
	 localStorage.removeItem('log');
	 $('#logPanel').html($('#logPanel').data('old'));
  }
  
  /*
  *
  * Oculta campos en el formulario de creacion de un nuevo punto de vertidos
  *
  */
  this.formHide= function(me){
	  if(me.attr('data')=='on'){
	  		me.parent().find('input.hide').attr('disabled','');
	  		me.attr('data','off');
	  }else{
	  		me.parent().find('input.hide').removeAttr('disabled');
	  		me.attr('data','on');
	  }
  }
  
   /*
  *
  * Funcion de apoyo que nos permite saber si un valor es numérico, esta funcion es utilizada al 
  * guardar los valores de un nuevo vertido
  *
  */
  this.isNumeric = function(n){
	  return !isNaN(parseFloat(n)) && isFinite(n);
  }
  
  /*
  *
  * Nos permite eliminar un vertido existente.
  *
  */
  this.deletePoint = function(id){
  	  //El usuario nos confirma
	  if(confirm("¿Seguro que desea eliminar esta empresa?, esta acción no se puede deshacer")){
		   //hacemos la petición
		   $.getJSON("http://tbp.cartodb.com/api/v2/sql?api_key=759428e7d8dcd4f2c6e6599f0c31a9bc71991387&q=DELETE FROM puntos  WHERE cartodb_id = " + id, function(data){
	  	if(data.total_rows){
	  		//Todo correcto, eliminamos de los resultados
	  		$('#resultsPanel').find(".result.result"+id).remove();
	  		//Refrescamos la capa, la variable r enviada al servidor CartoBD en el fichero CartoDB.js nos permite refrescar.
		  	if(featureLayer){
			  	featureLayer.redraw(true);
		  	}
		  	//Avismos al usuario
		  	alert("Eliminado correctamente, su nuevo punto desaparecerá inmediatamente");
	  	}else{
		  	alert("Se ha producido algun error al eliminar, ¡inténtelo de nuevo!");
	  	}			 
	 }); 
	  }
  }
  
  /*
  *
  * Permite al usuario almacenar un nuevo vertido 
  *
  */
  this.store = function(form){
		
	  var arr = [];	  
	  
	  //Guardamos la geometria de la capa vectorial que el usuario ha dibujado, la transformamos ya que CartoDB la espera en 
	  //4326 y nosotros la tenemos en 900913
	  
	  var wkt = new OpenLayers.Format.WKT();
	  
	  if(vectors.features.length==0){
		  return "Dibuje la geometria sobre el mapa antes de guardar";
	  }
	  
	  var tipo = $('#editPanel select').val();
	  var desc = $('#editPanel textarea').val();
	  var geom = "st_transform(st_GeomFromText('" +wkt.write(vectors.features[0])+ "',900913),4326)";
	  	  
	  //Hacemos la petición
	 $.getJSON("http://tbp.cartodb.com/api/v2/sql?api_key=759428e7d8dcd4f2c6e6599f0c31a9bc71991387&q=INSERT INTO puntos (the_geom,  tipo, descripcion) VALUES ("+geom+", '"+ tipo +"', '"+desc+"')",  function(data){
	  	if(data.total_rows){
	  		//Todo correcto, terminamos el proceso.
		  	mapa.endDrawingProcess();
		  	//Repintamos la capa
		  	mapa.getBase($('#editPanel select').val()).redraw(true);
		  	//Advertimos al usuario
		  	alert("Guardado correctamente, su nuevo punto aparecerá inmediatamente");
	  	}else{
		  	alert("Se ha producido algun error al guardar, ¡inténtelo de nuevo!");
	  	}			 
	 }); 
	 
	 return "";
	 
  }
  
  /*
  *
  * Permite al usuario almacenar un nuevo vertido 
  *
  */
  this.edit = function(id){
		
	  //Guardamos la geometria de la capa vectorial que el usuario ha dibujado, la transformamos ya que CartoDB la espera en 
	  //4326 y nosotros la tenemos en 900913
	  
	  var wkt = new OpenLayers.Format.WKT();
	  var tipo = $('#editPanel select').val();
	  var desc = $('#editPanel textarea').val();
	  var geom = "st_transform(st_GeomFromText('" +wkt.write(vectors.features[0])+ "',900913),4326)";
	  	  
	  //Hacemos la petición
	 $.getJSON("http://tbp.cartodb.com/api/v2/sql?api_key=759428e7d8dcd4f2c6e6599f0c31a9bc71991387&q=update puntos set the_geom="+geom+", tipo = '"+ tipo +"', descripcion = '"+desc+"' where cartodb_id=" + $('#editPanel select').data("id"),  function(data){
	  	if(data.total_rows){
	  		//Todo correcto, terminamos el proceso.
		  	mapa.endDrawingProcess();
		  	//Repintamos la capa
		  	mapa.getBase($('#editPanel select').val()).redraw(true);
		  	//Advertimos al usuario
		  	alert("Editado correctamente, su nuevo punto aparecerá inmediatamente");
	  	}else{
		  	alert("Se ha producido algun error al editar, ¡inténtelo de nuevo!");
	  	}			 
	 }); 
	 
	 return "";
	 
  }
  
  /*
  *
  * Nos permite obtener el mapa de openlayers desde fuera del módulo.
  *
  */
  this.getMap = function(){
  	return theMap;
  }
  
  this.editPoint = function(id){
		  $.getJSON('http://tbp.cartodb.com/api/v2/sql/?q=select st_astext(st_transform(the_geom, 900913)) as gm, * from puntos where cartodb_id = '+id, function(data){
				if(data.rows){
					if(data.rows.length>0){
					
						if(feature.on){
							mapa.activeFeature();
						}
					
						mapa.hideAllPanels();
						$('#editPanel').html($('#theEditingForm').html());
						$('#editPanel').show();
						$('#editPanel select').data("id", id);
						$('#editPanel select').val(data.rows[0].tipo);
						var t = mapa.getType($('#editPanel select').val());
						if(t=="p"){
							$('#editPanel option.a').remove();
							$('#editPanel option.l').remove();
						}else if(t=="l"){
							$('#editPanel option.a').remove();
							$('#editPanel option.p').remove();
						}else{
							$('#editPanel option.p').remove();
							$('#editPanel option.l').remove();
						}
						
						$('#editPanel textarea').val(data.rows[0].descripcion);
						
						vectors = new OpenLayers.Layer.Vector("Vector Layer");
						vectors.addFeatures(new OpenLayers.Format.WKT().read(data.rows[0].gm));	
						theMap.addLayer(vectors);
						editControl = new OpenLayers.Control.ModifyFeature(vectors);
						theMap.addControl(editControl);
						editControl.activate();		
					}
				}
						             
		  });   
  }
  
  /*
  * Dependiendo del tipo que el usuario selecciona en el desplegable comenzamos la edición
  */
  this.changeMode = function(){
	  
	  if(vectors){
		  this.getMap().removeLayer(vectors);
	  }
	  
	  vectors = new OpenLayers.Layer.Vector("Vector Layer");
		  //Cuando el usuario termine de dibujar la primera vez cambiamos el modo a edición
	  vectors.events.on({
	      	"sketchcomplete": this.beginEditFeature
	  });
	      //Añadimos la capa al mapa
	  theMap.addLayer(vectors);
	      //Creamos los controles de creación y edición de geometrias
	  
	  var mode = mapa.getType($('#editPanel select').val());
	  
	  if(mode=="p"){
			createControl = new OpenLayers.Control.DrawFeature(vectors, OpenLayers.Handler.Point);
	  }else if(mode=="l"){
			createControl = new OpenLayers.Control.DrawFeature(vectors, OpenLayers.Handler.Path);
	  }else{
			createControl = new OpenLayers.Control.DrawFeature(vectors, OpenLayers.Handler.Polygon);
	  }
	  
	  editControl = new OpenLayers.Control.ModifyFeature(vectors);
	  theMap.addControl(editControl);
	  theMap.addControl(createControl);
	  //Activamos el de creación
	  editControl.deactivate();
	  createControl.activate();
	  
  }
  
  /*
  * Comienzo del proceso de añadir un punto
  */
  this.beginCreateFeature = function(){
  		//Ocultamos todos los paneles
		mapa.hideAllPanels();
		//Rellenamos el panel con el formulario vacio para que poueda rellenarlo
		$('#editPanel').html($('#theForm').html());
		//Mostramos el panel de los datos del nuevo vertido
		$('#editPanel').show();
		//Ponemos en modo edición
		mapa.changeMode();
  }
  /*
  *
  * El usuario ya ha creado el punto, una vez hecho le permitimos editarlo
  *
  */
  this.beginEditFeature = function(){
		//Desactivamos el control de crear puntos
		createControl.deactivate();
		//Activamos el de editar el punto recien creado por si se ha equivocado
		editControl.activate();
  }

  /*
  *
  * Limpia la capa de edición
  *
  */
  this.cleanDrawingLayer = function(){
  		//Eliminamos todas las cosas pintadas
		vectors.removeAllFeatures();
		//Desactivamos el control de edición
		editControl.deactivate();
		//Activamos la creación
		createControl.activate(); 
  }
  
 /*
  *
  * Hemos terminado la edición del punto, limpiamos todo y volvemos a las opciones por defecto
  *
  */
  this.endDrawingProcess = function(){
  		//Ocultamos todos los paneles
		mapa.hideAllPanels();
		//Mostramos el panel de capas, por defecto activo
		$('#layerPanel').show();
		//Eliminamos la tabla vectorial, ya no nos hace falta
		//Desactivamos todos los controles si estan activos.
		if(vectors){
		  this.getMap().removeLayer(vectors);
	    }
  }
  
 /*
  *
  * Esta función centra el mapa en una posición, es utilizado para ver la posición de un resultado
  *
  */
  this.centerOn = function(wkt){
  	//Limpiamos el WKT que recibimos
  	var t = wkt.split("POINT(").join("").split(")").join("").split(" ");
  	//Si es correcto
  	if(t.length>1){
  		//Centrmos el mapa transformando de 4326 a 900913
	  	theMap.setCenter(
                new OpenLayers.LonLat(t[0], t[1]).transform(
                    new OpenLayers.Projection("EPSG:4326"),
                    mapa.getMap().getProjectionObject()
                ), 17
            );
  	} 
  }
  
  /**
  *
  * Añade los controles necesarios al mapa
  *
  **/
  this.addControls = function(){
  	//Añadimos el control de la barra de zoom
	theMap.addControl(new OpenLayers.Control.PanZoomBar());	
	//Creamos un nuevo control que extiende de feature  para poder seleccionar objetos en el mapa 
	feature = new OpenLayers.Control();
		OpenLayers.Util.extend(feature, {
				custom:true,
				on:false,
				draw: function () {
					this.box = new OpenLayers.Handler.Box( feature, {"done": mapa.handleFeature});
				}
		}); 
	theMap.addControl(feature);	  
  }
  
   /*
  *
  * Inicia el proceso de obtener información del mapa.
  *
  */
  this.activeFeature = function(force){
  	  //Si está activado
	  if(feature.on && !force){
	  	  //Lo desactivamos
	  	  featureLayer = null;
		  feature.box.deactivate();
		  feature.on = false;
		  $("#resultsPanel .control").attr("src","img/off.png");
		  $("#resultsPanel .desc").html("Consulta desactivada");
		  //$("#layerQuery").css("opacity","1");
	  }else{
	  	  //Lo activamos
	  	  if($("#resultsPanel select").val()){
		  	  featureLayer = eval($("#resultsPanel select").val());
	  	  }else{
		  	  featureLayer = null;
	  	  }
	  	  if(featureLayer!=null){
		  	  $("#resultsPanel .control").attr("src","img/on.png");
		  	  $("#resultsPanel .desc").html("Consulta activada");
			  feature.box.activate();
			  feature.on = true;
			  //$("#layerQuery").css("opacity","0.2");
		  }
	  }
  }
  
  /**
  *
  * Inicializa y añade las capas en el mapa
  *
  **/
  this.addLayers = function(){
	  		
	  		//Instanciamos las capas en el mapa, primero las que hacen de base
			phy = new OpenLayers.Layer.Google("Google Physical",{type: google.maps.MapTypeId.TERRAIN, visible:true, isBaseLayer: true});
            str = new OpenLayers.Layer.Google("Google Streets",{numZoomLevels: 20, visible:false,isBaseLayer: false});
            hyb = new OpenLayers.Layer.Google("Google Hybrid", {type: google.maps.MapTypeId.HYBRID, numZoomLevels: 20, visible:false,isBaseLayer: false});
            sat = new OpenLayers.Layer.Google("Google Satellite",{type: google.maps.MapTypeId.SATELLITE, numZoomLevels: 22, visible:false,isBaseLayer: false});
            //Despues otras
            
            //Las capas de CartoDB las añadimos mediante un tipo de capa llamado CartoDB, que he extendido de XYZ
            
            limite = new OpenLayers.Layer.CartoDB( "Límite confederación del Duero", "https://tbp.cartodb.com/tiles/confederacion/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: true,
            		isBaseLayer: false
            	});
            
            ren = new OpenLayers.Layer.CartoDB( "Red de Espacios Naturales", "https://tbp.cartodb.com/tiles/ren/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false
            	});
            vulnerables = new OpenLayers.Layer.CartoDB( "Zonas vulnerables", "https://tbp.cartodb.com/tiles/vulnerables/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false
            	});
            
            rios = new OpenLayers.Layer.CartoDB( "Rios", "https://tbp2.cartodb.com/tiles/rios/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false
            	});
            	
            fuentesPuntuales = new OpenLayers.Layer.CartoDB( "fuentesPuntuales", "https://tbp.cartodb.com/tiles/puntos/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false,
            		sql:'select *, st_astext(the_geom) as geom_text from puntos where tipo = 101',
            		style:this.getCartoCSS("101")
            	});
            	
             fuentesDifusas= new OpenLayers.Layer.CartoDB( "fuentesDifusas", "https://tbp.cartodb.com/tiles/puntos/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false,
            		sql:'select *, st_astext(the_geom) as geom_text from puntos where tipo = 201',
            		style:this.getCartoCSS("201")
            	});
            
             extracciones= new OpenLayers.Layer.CartoDB( "extracciones", "https://tbp.cartodb.com/tiles/puntos/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false,
            		sql:'select *, st_astext(the_geom) as geom_text from puntos where tipo = 301',
            		style:this.getCartoCSS("301")
            	});
            	
            	regulaciones= new OpenLayers.Layer.CartoDB( "regulaciones", "https://tbp.cartodb.com/tiles/puntos/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false,
            		sql:'select *, st_astext(the_geom) as geom_text from puntos where tipo = 401',
            		style:this.getCartoCSS("401")
            	});
            	
               morfologicas= new OpenLayers.Layer.CartoDB( "morfologicas", "https://tbp.cartodb.com/tiles/puntos/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false,
            		sql:'select *, st_astext(the_geom) as geom_text from puntos where tipo = 501',
            		style:this.getCartoCSS("501")
            	});
            	
            	antropogenicas= new OpenLayers.Layer.CartoDB( "antropogenicas", "https://tbp.cartodb.com/tiles/puntos/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false,
            		sql:'select *, st_astext(the_geom) as geom_text from puntos where tipo = 601',
            		style:this.getCartoCSS("601")
            	});
            	
            	usos= new OpenLayers.Layer.CartoDB( "usos", "https://tbp.cartodb.com/tiles/puntos/${z}/${x}/${y}.png",
            	{
            		sphericalMercator: true,
            		buffer: 1,
            		numZoomLevels: 18,
            		visibility: false,
            		isBaseLayer: false,
            		sql:'select *, st_astext(the_geom) as geom_text from puntos where tipo = 701',
            		style:this.getCartoCSS("701")
            	});
            
            //Las añadimos	
            theMap.addLayers([ str, hyb, sat, phy, limite, ren, vulnerables,  rios,  fuentesPuntuales, fuentesDifusas, extracciones, regulaciones, morfologicas, antropogenicas, usos]);
  }
  
  /**
  *
  * Controla el estado de las capas cada vez que el usuario pulsa para activarla o desactivarla
  * tiene un comportamiento diferente para las que hacen de base y opcionales
  *
  **/
  this.layerStatus = function(name, element, base){
	 
	 if(base){
	 		
	 		//Es base, desactivamos todas, iconos y atributo que nos dice el estado
	 				
	 		var status = element.attr("data") == "on";
	 		
	 		$("#layerPanel .phy .imageIcon").attr("src","img/off.png");
		 	$("#layerPanel .phy .status").attr("data","off");
		 	$("#layerPanel .str .imageIcon").attr("src","img/off.png");
		 	$("#layerPanel .str .status").attr("data","off");
	 		$("#layerPanel .hyb .imageIcon").attr("src","img/off.png");
		 	$("#layerPanel .hyb .status").attr("data","off");
		 	$("#layerPanel .sat .imageIcon").attr("src","img/off.png");
		 	$("#layerPanel .sat .status").attr("data","off");
	 		
	 		phy.setVisibility(false);
		 	str.setVisibility(false);
	 		hyb.setVisibility(false);
		 	sat.setVisibility(false);
	 		
	 		
	 		if(!status){
		 		//Activamos la que el usuario nos pide
			 	$("#layerPanel ." +name+ " .imageIcon").attr("src","img/on.png");
			 	$("#layerPanel ." +name+ " .status").attr("data","on");
			 	//Utilizamos la evaluiacion para obtener la variable por su nombre
			 	var layer = eval(name);
			 	//Cambiamos el estado
			 	layer.setVisibility(!status);
			}else{
				//Ha desactivado todas, encendemos la de por defecto
				$("#layerPanel .phy .imageIcon").attr("src","img/on.png");
				$("#layerPanel .phy .status").attr("data","on");
				phy.setVisibility(true);
			}
	 			 						
	 }else{
	 	 
	 	 //No es base, por lo tanto la activamos o desactivamos
		 var status = element.attr("data") == "on";
		 if(!status){
			 $("#layerPanel ." +name+ " .imageIcon").attr("src","img/on.png");
			 $("#layerPanel ." +name+ " .status").attr("data","on");
			 
		 }else{
			$("#layerPanel ." +name+ " .imageIcon").attr("src","img/off.png");
			$("#layerPanel ." +name+ " .status").attr("data","off"); 
		 }
		 
		 if(element.parent().find('.config').length>0){
			 if(!status){
				 $("#resultsPanel select").append('<option class="'+name+'" value="'+name+'">'+ element.parent().find(".ttl").html() +'</option>');
			 }else{
				 $("#resultsPanel select").find("option."+name).remove();
			 }
		 }
		 
		 //Utilizamos la evaluiacion para obtener la variable por su nombre
		 var layer = eval(name);
		 //Cambiamos el estado
		 layer.setVisibility(!status);
		 
	 }
	 
  }
  
  /**
  *
  * Controla el estado de las subcapas cada vez que el usuario pulsa para activarla o desactivarla
  *
  **/
  this.subLayerStatus = function(name, element, subname){
	  
	  /*if(name=="vertidos"){
		  
		  if(subname=="inor"){
			  vertidos.setSQL("select *, st_astext(the_geom) as geom_text from vertidos where c_inor = 1");
		  }else if(subname=="orga"){
			  vertidos.setSQL("select *, st_astext(the_geom) as geom_text from vertidos where c_orga = 1");
		  }else if(subname=="nutr"){
			  vertidos.setSQL("select *, st_astext(the_geom) as geom_text from vertidos where c_nutr = 1");
		  }else if(subname == "ilegal"){
			  vertidos.setSQL("select *, st_astext(the_geom) as geom_text from vertidos where 1=1");
		  }else{
			  vertidos.setSQL("select *, st_astext(the_geom) as geom_text from vertidos where c_temp = 1");
		  }
		  
		  element.parent().parent().find(".subImageIcon").attr("data","off");
		  element.parent().parent().find(".subImageIcon").attr("src","img/off.png");
		  element.attr("data","on");
		  element.attr("src","img/on.png");
		  element.parent().parent().parent().find(".theLegend").attr("src", element.attr("legend"));
		  
		  vertidos.setStyle(this.getCartoCSS(subname));
		  vertidos.redraw(true);
	  }*/
	  
	  element.parent().parent().find(".subImageIcon").attr("data","off");
	  element.parent().parent().find(".subImageIcon").attr("src","img/off.png");
	  element.attr("data","on");
	  element.attr("src","img/on.png");
	  element.parent().parent().parent().find(".theLegend").attr("src", element.attr("legend"));
	  
	  if(name == "fuentesPuntuales"){
	  	  fuentesPuntuales.setSQL("select *, st_astext(the_geom) as geom_text from puntos where tipo = " + subname);
	  	  fuentesPuntuales.setStyle(this.getCartoCSS(subname));
		  fuentesPuntuales.redraw(true);
	  }
	  
	  if(name == "fuentesDifusas"){
	  	  fuentesDifusas.setSQL("select *, st_astext(the_geom) as geom_text from puntos where tipo = " + subname);
	  	  fuentesDifusas.setStyle(this.getCartoCSS(subname));
		  fuentesDifusas.redraw(true);
	  }
	  
	  if(name == "extracciones"){
	  	  extracciones.setSQL("select *, st_astext(the_geom) as geom_text from puntos where tipo = " + subname);
	  	  extracciones.setStyle(this.getCartoCSS(subname));
		  extracciones.redraw(true);
	  }
	  
	  if(name == "regulaciones"){
	  	  regulaciones.setSQL("select *, st_astext(the_geom) as geom_text from puntos where tipo = " + subname);
	  	  regulaciones.setStyle(this.getCartoCSS(subname));
		  regulaciones.redraw(true);
	  }
	  
	  if(name == "morfologicas"){
	  	  morfologicas.setSQL("select *, st_astext(the_geom) as geom_text from puntos where tipo = " + subname);
	  	  morfologicas.setStyle(this.getCartoCSS(subname));
		  morfologicas.redraw(true);
	  }
	  
	  if(name == "antropogenicas"){
	  	  antropogenicas.setSQL("select *, st_astext(the_geom) as geom_text from puntos where tipo = " + subname);
	  	  antropogenicas.setStyle(this.getCartoCSS(subname));
		  antropogenicas.redraw(true);
	  }
	  
	  if(name == "usos"){
	  	  usos.setSQL("select *, st_astext(the_geom) as geom_text from puntos where tipo = " + subname);
	  	  usos.setStyle(this.getCartoCSS(subname));
		  usos.redraw(true);
	  }
  
  }
  
   /*
  *
  * Le pasamos un nombre y nos devuelve el estilo que necesitamos.
  *
  */
  this.getCartoCSS = function(style){
	  
	  
	  
	  if(style=="102"){
		  return "#puntos{ marker-fill: #FFA300; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
	  }else if(style=="101"){
		  return "#puntos{ marker-fill: #FF5C00; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
	   }else if(style=="203"){
		  return "#puntos{ marker-fill: #CC0000; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
	  }else if(style=="210"){
		  return "#puntos{ marker-fill: #990033; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
      }else if(style=="301"){
		  return "#puntos{ marker-fill: #3399FF; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
	  }else if(style=="501"){
		  return "#puntos{ marker-fill: #009900; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
	  }else if(style=="502"){
		  return "#puntos{ marker-fill: #66CC00; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
      }else if(style=="505"){
		  return "#puntos{ marker-fill: #999900; marker-opacity: 0.9; marker-allow-overlap: true;  marker-placement: point; marker-type: ellipse;  marker-width: 4; marker-line-width: 2;  marker-line-color: #FFF; marker-line-opacity: 0.9; }";
	  }else if(style=="204"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #CC0033; line-width: 2;}";
	  }else if(style=="401"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #990066; line-width: 2;}"; 
	  }else if(style=="402"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #9966FF; line-width: 2;}"; 
	  }else if(style=="403"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #CC3399; line-width: 2;}";
	  }else if(style=="503"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #003300; line-width: 2;}";
	  }else if(style=="504"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #006600; line-width: 2;}"; 
	  }else if(style=="507"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #99FF00; line-width: 2;}"; 
	  }else if(style=="506"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #669900; line-width: 2;}"; 
	  }else if(style=="508"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #999900; line-width: 2;}"; 
	  }else if(style=="603"){
		  return "#puntos{ ::borderback { line-width: 2; }line-color: #333333; line-width: 2;}";
	  }else if(style=="201"){
		  return "#puntos{  polygon-fill: #FF0000;line-width: 2; line-color: #FFF}";
	  }else if(style=="202"){
		  return "#puntos{  polygon-fill: #990000;line-width: 2; line-color: #FFF}";
	  }else if(style=="205"){
		  return "#puntos{  polygon-fill: #990033;line-width: 2; line-color: #FFF}";
	  }else if(style=="206"){
		  return "#puntos{  polygon-fill: #CC3333;line-width: 2; line-color: #FFF}";
	  }else if(style=="207"){
		  return "#puntos{  polygon-fill: #FF4242;line-width: 2; line-color: #FFF}";
	  }else if(style=="208"){
		  return "#puntos{  polygon-fill: #490E00;line-width: 2; line-color: #FFF}";
	  }else if(style=="209"){
		  return "#puntos{  polygon-fill: #DE3A3A;line-width: 2; line-color: #FFF}";
	  }else if(style=="601"){
		  return "#puntos{  polygon-fill: #999999;line-width: 2; line-color: #FFF}";
	  }else if(style=="602"){
		  return "#puntos{  polygon-fill: #666666;line-width: 2; line-color: #FFF}";
	  }else if(style=="701"){
		  return "#puntos{  polygon-fill: #CC00CC;line-width: 2; line-color: #FFF}";
	  }else if(style=="702"){
		  return "#puntos{  polygon-fill: #CC99FF;line-width: 2; line-color: #FFF}";
	  }else if(style=="703"){
		  return "#puntos{  polygon-fill: #CCCCFF;line-width: 2; line-color: #FFF}";
	  }else if(style=="704"){
		  return "#puntos{  polygon-fill: #FF66FF;line-width: 2; line-color: #FFF}";
	  }else if(style=="705"){
		  return "#puntos{  polygon-fill: #FF99CC;line-width: 2; line-color: #FFF}";
	  }
	  
	  return "";
  }
  
  //devuelve el nombre coloquial
  this.getName = function(style){

	  if(style=="102"){
		  return "Vertedero";
	  }else if(style=="101"){
		  return "Vertido";
	   }else if(style=="203"){
		  return "Aeropuerto";
	  }else if(style=="210"){
		  return "Gasolinera";
      }else if(style=="301"){
		  return "Concesión de agua";
	  }else if(style=="501"){
		  return "Presa";
	  }else if(style=="502"){
		 return "Azude";
      }else if(style=="505"){
		  return "Dragado";
	  }else if(style=="204"){
		  return "Via de transporte";
	  }else if(style=="401"){
		  return "Regulación de embalse"; 
	  }else if(style=="402"){
		  return "Desvio Hidroeléctrico"; 
	  }else if(style=="403"){
		  return "Inc. por trasvase";
	  }else if(style=="503"){
		  return "Canalización";
	  }else if(style=="504"){
		  return "Protección de margen"; 
	  }else if(style=="507"){
		  return "Modificación de conexion"; 
	  }else if(style=="506"){
		  return "Recrecimiento de lago"; 
	  }else if(style=="508"){
		  return "Cobertura de cauce"; 
	  }else if(style=="603"){
		  return "Actividad recreativa";
	  }else if(style=="201"){
		  return "Agricultura";
	  }else if(style=="202"){
		  return "Ganaderia";
	  }else if(style=="205"){
		  return "Suelo contaminado";
	  }else if(style=="206"){
		  return "Zona urbana";
	  }else if(style=="207"){
		  return "Zona minera";
	  }else if(style=="208"){
		  return "Zona recreativa";
	  }else if(style=="209"){
		  return "Pradera";
	  }else if(style=="601"){
		  return "Especie alóctona";
	  }else if(style=="602"){
		  return "Sedimento contaminado";
	  }else if(style=="701"){
		  return "Incendio forestal";
	  }else if(style=="702"){
		  return "Explotación forestal";
	  }else if(style=="703"){
		  return "Ocupación de margen";
	  }else if(style=="704"){
		  return "Extracción de árido";
	  }else if(style=="705"){
		  return "Otros elementos";
	  }
	  
	  return "";
  }
  
    //devuelve la capa base
  this.getBase = function(style){

	  if(style=="102"){
		  return fuentesPuntuales;
	  }else if(style=="101"){
		  return fuentesPuntuales;
	   }else if(style=="203"){
		  return fuentesDifusas;
	  }else if(style=="210"){
		  return fuentesDifusas;
      }else if(style=="301"){
		  return extracciones;
	  }else if(style=="501"){
		  return morfologicas;
	  }else if(style=="502"){
		 return morfologicas;
      }else if(style=="505"){
		  return morfologicas;
	  }else if(style=="204"){
		  return fuentesDifusas;
	  }else if(style=="401"){
		  return regulaciones; 
	  }else if(style=="402"){
		  return regulaciones; 
	  }else if(style=="403"){
		  return regulaciones;
	  }else if(style=="503"){
		  return morfologicas;
	  }else if(style=="504"){
		  return morfologicas; 
	  }else if(style=="507"){
		  return morfologicas; 
	  }else if(style=="506"){
		  return morfologicas; 
	  }else if(style=="508"){
		  return morfologicas; 
	  }else if(style=="603"){
		  return antropogenicas;
	  }else if(style=="201"){
		  return fuentesDifusas;
	  }else if(style=="202"){
		  return fuentesDifusas;
	  }else if(style=="205"){
		  return fuentesDifusas;
	  }else if(style=="206"){
		  return fuentesDifusas;
	  }else if(style=="207"){
		  return fuentesDifusas;
	  }else if(style=="208"){
		  return fuentesDifusas;
	  }else if(style=="209"){
		  return fuentesDifusas;
	  }else if(style=="601"){
		  return antropogenicas;
	  }else if(style=="602"){
		  return antropogenicas;
	  }else if(style=="701"){
		  return usos;
	  }else if(style=="702"){
		  return usos;
	  }else if(style=="703"){
		  return usos;
	  }else if(style=="704"){
		  return usos;
	  }else if(style=="705"){
		  return usos;
	  }
	  
	  return usos;
  }
  
  
  //devuelve el tipo de geometria
  this.getType = function(style){

	  if(style=="102"){
		  return "p";
	  }else if(style=="101"){
		  return "p";
	   }else if(style=="203"){
		  return "p";
	  }else if(style=="210"){
		  return "p";
      }else if(style=="301"){
		  return "p";
	  }else if(style=="501"){
		  return "p";
	  }else if(style=="502"){
		 return "p";
      }else if(style=="505"){
		  return "p";
	  }else if(style=="204"){
		  return "l";
	  }else if(style=="401"){
		  return "l"; 
	  }else if(style=="402"){
		  return "l"; 
	  }else if(style=="403"){
		  return "l";
	  }else if(style=="503"){
		  return "l";
	  }else if(style=="504"){
		  return "l"; 
	  }else if(style=="507"){
		  return "l"; 
	  }else if(style=="506"){
		  return "l"; 
	  }else if(style=="508"){
		  return "l"; 
	  }else if(style=="603"){
		  return "l";
	  }else if(style=="201"){
		  return "a";
	  }else if(style=="202"){
		  return "a";
	  }else if(style=="205"){
		  return "a";
	  }else if(style=="206"){
		  return "a";
	  }else if(style=="207"){
		  return "a";
	  }else if(style=="208"){
		  return "a";
	  }else if(style=="209"){
		  return "a";
	  }else if(style=="601"){
		  return "a";
	  }else if(style=="602"){
		  return "a";
	  }else if(style=="701"){
		  return "a";
	  }else if(style=="702"){
		  return "a";
	  }else if(style=="703"){
		  return "a";
	  }else if(style=="704"){
		  return "a";
	  }else if(style=="705"){
		  return "a";
	  }
	  
	  return "";
  }

  
  //gestiona las peticiones de datos
  this.handleFeature = function(bounds){
			
			if(featureLayer==null){
				return ;
			}
			
			var TOLERANCIA=12;            
            var sql = featureLayer.getSQL();
            
            //Determinamos si ha hecho simplemente clic o ha dibujado un rectangulo
            if((bounds.toString().indexOf("x=")>-1) && (bounds.toString().indexOf("y=") > -1) ){
                //Tenemos un punto convertimos a 4326, nativo de CartoDB
                var np = mapa.getMap().getLonLatFromPixel(new OpenLayers.Pixel(bounds.x, bounds.y));
                var buffer =  (TOLERANCIA * mapa.getMap().getResolution());               
                //Hay casos en los que hacer clic en una feature es dificil ya que es demasiado pequeña a zooms altos
                //por eso creamos una tolerancia que es mayor cuanto más alto es el zoom, para eso utilizamos la resolucion 				//del mapa .Si utilizamos 4326, no es el caso en el mapa, pero sí en cartoDB, la unidad de medida son grados, 				//como estamos utilizando 900913 tiene como unidad m, esto es muy importante para la función st_buffer de postgis.
                //Con un comando SQL creamos el punto mediante st_pointfromtext y le damos el epsg del mapa, en este caso 900913, sobre esta geometria creamos un buffer en m, ya que el EPSG así lo define y lo convertimos al EPSG nativo de cartoDB 4326 para la intersección, esto reduce el número de conversiones, ya que podríamos convertir toda la columna the_geom.
                sql = sql + " AND ST_Intersects(the_geom, st_transform(st_buffer(st_PointFromText('POINT(" +np.lon+ " " + np.lat +")',900913),"+buffer+"), 4326))";
            }else{
                //Ha pintado un poligono, ahora no necesitamos buffers ni nada parecido. Con las dos coordenadas dibujamos una caja y comprobamos la interseccion.
                var lt = mapa.getMap().getLonLatFromPixel(new OpenLayers.Pixel(bounds.left, bounds.top)); 
                var rb = mapa.getMap().getLonLatFromPixel(new OpenLayers.Pixel(bounds.right, bounds.bottom)); 
                sql = sql + " AND ST_Intersects(the_geom, st_transform(st_setsrid(st_MakeBox2d(st_PointFromText('POINT(" +lt.lon+ " " + lt.lat +")',900913), st_PointFromText('POINT(" +rb.lon+ " " + rb.lat +")',900913)),900913),4326))";
            }
            
             //Hacemos una petición a CartoDB atrevés del API SQL
             
             $.getJSON('http://tbp.cartodb.com/api/v2/sql/?q='+sql, function(data){
	             $("#resultsPanel .results").html('');
	             lresult = data.rows;
	             if(data.rows.length>0){
	             	$.each(data.rows, function(key, val) {
	             		var tipo = mapa.getName(val.tipo);
	             		var v = "<b>Descripción: </b>" + val.descripcion+"<br/>";
	             		
		            	$("#resultsPanel .results").append('<div class="result result'+val.cartodb_id+'" data="'+key+'">'+tipo+'<div class="layerIcon res"><img class="imageIcon" onclick="mapa.centerOn(\''+val.geom_text+'\')" title="Centra el mapa en este resultado" src="img/marker.png"></div><div class="layerIcon res"><img title="Muestra la informacion del resultado" onclick="$(this).parent().parent().find(\'.resultDescription\').toggle()" src="img/info.png"><img class="imageIcon locked" onclick="mapa.deletePoint('+ val.cartodb_id+')" title="Elimina este riesgo" src="img/delete.png"><img class="imageIcon locked" onclick="mapa.editPoint('+ val.cartodb_id+')" title="Edita este riesgo" src="img/edit.png"></div><div class="resultDescription"><br/>'+v+'</div></div>');
	             	});
	             	
	             	if(localStorage.getItem('log')){
		             	$(".locked").show();
	             	}else{
		             	$(".locked").hide();
	             	}
	             	
	             	mapa.hideAllPanels();$("#resultsPanel").show();
		         }else{
			         $("#resultsPanel .result").html('<span class="title">... No hay resultados ...</span><br/><br/>');
		         }
		     }); 
           	
	}
  
  
  /**
  *
  * Las siguientes lineas se ejecutan en la inicializacion del módulo con los parametros pasados
  *
  **/
  
  //Si nos pasa el div en el que crear el mapa lo iniciamos, sino salimos
  if(args.container){
  	container = args.container;
  }else{
  	return;
  }
  
  //Fijamos el estilo de los controles de openlayers
  OpenLayers.ImgPath = "http://js.mapbox.com/theme/dark/";
  //Inicializamos el mapa
  theMap = new OpenLayers.Map(container, {numZoomLevels: 21, controls: [new OpenLayers.Control.Navigation()]});
  //Llamamos a las funciones que añaden capas y controles
  this.addLayers();
  this.addControls();
  //Centramos el mapa en una posicion
  theMap.setCenter( new OpenLayers.LonLat( -4.5703119970858, 41.797485016287).transform(
                    new OpenLayers.Projection("EPSG:4326"),
                    theMap.getProjectionObject()
                ), 8);
  //Aunque no se especifica trabajamos con el EPSG:900913 [:) popularizado por Google, si se sustituye el 9 por G el uno por una L y el 3 por una e inversa] que es una proyeccion esférica mercator  
  

}